pipeline {
    agent any
    environment {
        TEST_VAR="Test"
        //TO DO
        //Set up DB_HOST, DB_DATABASE, DB_USERNAME, DB_PASSWORD as environment variables.
        //DB_USERNAME, DB_PASSWORD should be get from secret text credentials.
        DB_HOST="46.137.226.161:3306";
        DB_DATABASE="vyth1";
        DB_USERNAME=credentials("fd718aca-2b51-4325-b4ae-ae16a1fdfa2c");
        DB_PASSWORD=credentials("459f6489-f9f4-4255-8b69-14439871e6a3");
        
    }
    stages{
        stage("Checkout code") {
        steps{
            sh "echo Checkout code"
            //TO DO
            // Use a git step to full the code from your gitlab account.
            git branch: 'master',
            url: 'https://gitlab.com/vytran.bkdn/final-jenkins.git'
        }
            
        }
        stage("Modify code") {
        steps{
            sh "echo Modify code"
            //TO DO
            // Replace information in web/config.php with your your credentials and the environment variables above
            sh "sed -i 's/localhost/${DB_HOST}/g' web/config.php"
            sh "sed -i 's/username/${DB_USERNAME}/g' web/config.php"
            sh "sed -i 's/password/${DB_PASSWORD}/g' web/config.php"
            sh "sed -i 's/database/${DB_DATABASE}/g' web/config.php"
            sh "cat web/config.php"
        }
            
        }
        stage("Setup database") {
        steps{
            sh "echo Setup database"
             //TO DO : Setup the database using mysql commandline with your credentials and the environment variables above
             // -	Drop database if exits
             // -	Create database
             // -	Import init/tables.sql
             // -	Import init/insert-data.sql
            sh "mysql -u ${DB_USERNAME} -p${DB_PASSWORD} -h ${DB_HOST} -P 3306 -e 'DROP DATABASE IF EXISTS ${DB_DATABASE};'"
            sh "mysql -u ${DB_USERNAME} -p${DB_PASSWORD} -h ${DB_HOST} -P 3306 -e 'CREATE DATABASE ${DB_DATABASE};'"
            sh "mysql -u ${DB_USERNAME} -p${DB_PASSWORD} -h ${DB_HOST} -P 3306 ${DB_DATABASE} < init/tables.sql"
            sh "mysql -u ${DB_USERNAME} -p${DB_PASSWORD} -h ${DB_HOST} -P 3306 ${DB_DATABASE} < init/insert-data.sql"

        }
            
        }        
        stage("Deploy code") {
        steps{
            sh "echo Deploy Code"
            //TODO 
            // -	Create folder if not exists: $JENKINS_HOME/www/{your account name}
            // -	Copy all codes from “web” to that folder (you overwrite the existing files).
            // -	DON’T use any “rm” command.
            // The website should be available at: https://web.turbo.lviv.ua/{your account name}

        }
            
        }
    }
}
